*** IncldProcess(<output file handle>,<current topic id>,<src path>)
** this assumes that the record pointer has been set externally, by the 
** calling program. This creates a temp file holding include file data
** it writes a jump to the include file section into the main topic
** returns updated topic id value or -1 for fault
lparameters hOutFile, nCurID, cSrcPath
local ;
   cIncName ;
   cIncldFile ;
   cName ;
   cOutLine ;
   cProcDesc ;
   lHidnProc ;
   lSkipProcess ;
   nExtInx ;
   nFoxProc ;
   nOrgMemoWidth ;
   nMInx ;
   nMthdHidn ;
   nMthdLines ;
   nMthdProt ;
   nMthdPub ;
   nProtLine

* set lSkipProcess false - enables include processing
lSkipProcess = .F.

* set memowidth to size large enough to avoid truncating each method line
nOrgMemoWidth = set('memowidth')
set memowidth to 500

* check to see if there is an include file
cIncldFile = reserved8
cIncName = cIncldFile
cIncName = strtran(cIncName,'\','\\')
if empty(cIncldFile)
   return 0
endif

* create descriptive section in main class section
fputs(hOutFile,'\par Include File: \par')

* create jump to include file listing
cOutLine = '{\uldb '
cOutLine = cOutLine + cIncName
cOutLine = cOutLine + '}{\v IDH_'
cOutline = cOutLine + alltrim(str(nCurID))
cOutLine = cOutLine + '} \par'
fputs(hOutFile,cOutLine)

* create include text section
* create a temporary file for this object
hTFile = CreateTempFile()
if hTFile = -1
   messagebox('Temp File Creation FAILED.',16)
   lSkipProcess = .T.
endif

cIncld = cSrcPath + cIncldFile
hIncld = fopen(cIncld)
if hIncld = -1
   messagebox('FAILED to open Include File.',16)
   lSkipProcess = .T.
endif
   
if NOT lSkipProcess
   * create footnote info for this procedure
   nRtnVal = FootGen(hTFile,nCurID,'Include File ' + cIncName)
   if nRtnVal = -1
      messagebox('FootNote Creation FAILED.',16)
      lSkipProcess = .T.
   else
      nCurID = nCurID + 1
   endif
endif

if NOT lSkipProcess
   * create Topic Title and center it in display
   fputs(hTFile,'{\f4\fs20 \b ' + 'Include File ' + cIncName + '\par }')

   * set formating back to plain
   fputs(hTFile,'{\pard\plain \li120 \f4\fs20 ')
   * extract actual procedure data and write to temp file
   do while NOT feof(hIncld)
      cCurLine = fgets(hIncld)
      cCurLine = strtran(cCurLine,'\','\\')
      cCurLine = strtran(cCurLine,'{','\{')
      cCurLine = strtran(cCurLine,'}','\}')
      fputs(hTFile,cCurLine + ' \par')
   enddo
   fputs(hTFile,'\par }')
   fputs(hTFile,'{\page }')
   fclose(hTFile)
endif

* set memowidth to starting value
set memowidth to nOrgMemoWidth

return nCurID
