*** AutoHelp()
** creates help file from library file and adds it to foxpro help
** system. adds entries for index linking into main foxpro help

* get library to scan
cTmpFileNm = getfile('vcx')
if empty(cTmpFileNm)
   messagebox('HelpGeneration ABORTED.')
   return .F.
endif   

* extract library name from file id string
cCompFile = SUBSTR(cTmpFileNm,RAT('\',cTmpFileNm) + 1)
IF RAT('.',cCompFile) <> 0
   cCompFile = SUBSTR(cCompFile,1,RAT('.',cCompFile) - 1)
ENDIF

* extract file path from file id string
cLibPath = ''
IF RAT('\',cTmpFileNm) <> 0
   cLibPath = SUBSTR(cTmpFileNm,1,RAT('\',cTmpFileNm))
ENDIF

* get option settings for output
do form HelpOptions to nHelpOpt

* generate help source files
* create actual topic text, keyword, TOC, and jump information
if !BodyGen(cLibPath, cCompFile)
   messagebox('Source Body Creation FAILED.',16)
   return
endif

* create help project file
CreateHelpProj(cCompFile)

* compile help files and transfer to windows help directory
HelpComp = getfile("exe","HCW.exe","",1, "Where is hcw.exe")
!/N &HelpComp /a/c &cCompFile
messagebox('WAIT until help compiler finishes.')

* transfer to windows\help if option is selected
* if this option is NOT selected DO NOT update foxhelp system
HelpDir = sys(5) + sys(2003)
if bittest(nHelpOpt,0)
   messagebox('transfering help file to help dir')
   cFileName = cCompFile + '.hlp'
   copy file &cFileName to HelpDir
   cFileName = cCompFile + '.cnt'
   copy file &cFileName to HelpDir
else
   nHelpOpt = 0
endif

cHelpContents = sys(2004) + 'foxhelp.cnt'

* check to see if an entry should be added to the table of contents
if bittest(nHelpOpt,1)
   if TOCAdd(cHelpContents,cCompFile,'TOC') = -1
      messagebox('TOC Add FAILED')
   endif
endif

* see if an entry should be added for indexing
if bittest(nHelpOpt,2)
   if TOCAdd(cHelpContents,cCompFile,'INDEX') = -1
      messagebox('Index Add FAILED')
   endif
endif

return
