*** MthdProcess(<output file handle>,<current topic id>)
** this assumes that the record pointer has been set externally, by the 
** calling program. This seperates methods into individual sections, 
** orders them, and writes them to the output file, it also assigns 
** jumps from the main class section to the individual segments
** returns updated topic id value or -1 for fault
lparameters hOutFile, nCurID
local ;
   cName ;
   cOutLine ;
   cProcDesc ;
   lHidnProc ;
   lSkipProcess ;
   nExtInx ;
   nFoxProc ;
   nOrgMemoWidth ;
   nMInx ;
   nMthdHidn ;
   nMthdLines ;
   nMthdProt ;
   nMthdPub ;
   nProtLine

* set method array indexes to 1
nFoxProc = 1
nMthdHidn = 1
nMthdProt = 1
nMthdPub = 1
* set lSkipProcess false - enables procedure processing
lSkipProcess = .F.

* set memowidth to size large enough to avoid truncating each method line
nOrgMemoWidth = set('memowidth')
set memowidth to 500

* check to see if there are methods defined
nMthdLines = memlines(methods)
if nMthdLines = 0
   return 0
endif

* scan for list of methods
for nMInx = 1 to nMthdLines
   cLine = mline(methods,nMInx)
   * verify there is data in cLine
   if NOT empty(cLine) AND left(cLine,9) = 'PROCEDURE'
      * extract name
      cName = substr(cLine,11)
      * check to see if this is a user defined procedure
      nProcLine = atcline(cName,reserved3)
      if nProcLine > 0
         * set up user defined parameters
         * check to see if there is a description line
         nSpaceChar = atc(' ',cLine,1)
         if nSpaceChar > 0
            * extract description text
            cProcDesc = alltrim(substr(cLine,nSpaceChar+1))
         else
            cProcDesc = 'None Written'
         endif
         * check to see if this is a protected or hidden procedure
         nProtLine = atcline(cName,protected)
         lHidnProc = iif(right(mline(protected,nProtLine),1) = '^',.T.,.F.)
      endif
      * create procedure type arrays
      do case
         case nProcLine = 0
            dimension aFoxProc[nFoxProc,4]
            aFoxProc[nFoxProc,1] = cName
            aFoxProc[nFoxProc,2] = nCurID
            aFoxProc[nFoxProc,3] = cLine
            aFoxProc[nFoxProc,4] = ''
            nFoxProc = nFoxProc + 1
            nCurID = nCurID + 1

         case nProcLine > 0 AND nProtLine = 0
            dimension aMthdPub[nMthdPub,4]
            aMthdPub[nMthdPub,1] = cName
            aMthdPub[nMthdPub,2] = nCurID
            aMthdPub[nMthdPub,3] = cLine
            aMthdPub[nMthdPub,4] = cProcDesc
            nMthdPub = nMthdPub + 1
            nCurID = nCurID + 1

         case nProcLine > 0 AND nProtLine > 0 AND NOT lHidnProc
            dimension aMthdProt[nMthdProt,4]
            aMthdProt[nMthdProt,1] = cName
            aMthdProt[nMthdProt,2] = nCurID
            aMthdProt[nMthdProt,3] = cLine
            aMthdProt[nMthdProt,4] = cProcDesc
            nMthdProt = nMthdProt + 1
            nCurID = nCurID + 1

         case nProcLine > 0 AND nProtLine > 0 AND lHidnProc
            dimension aMthdHidn[nMthdHidn,4]
            aMthdHidn[nMthdHidn,1] = cName
            aMthdHidn[nMthdHidn,2] = nCurID
            aMthdHidn[nMthdHidn,3] = cLine
            aMthdHidn[nMthdHidn,4] = cProcDesc
            nMthdHidn = nMthdHidn + 1
            nCurID = nCurID + 1

      endcase
   endif 
endfor

* create descriptive sections in main class section
* do FoxProc section first
if nFoxProc > 1
   * order function names
   asort(aFoxProc)
   * create section header
   fputs(hOutFile,'\par Re-Defined FoxPro Basic Methods: \par')
   * step through each function and write description to main topic
   for nMInx = 1 to alen(aFoxProc,1)
      nExtInx = 1
      nStartLine = atcline(aFoxProc[nMInx,3],methods)
      if nStartLine > 0
         cCurLine = mline(methods,nStartLine + nExtInx)
         do while left(cCurLine,2) = '**'
            if left(cCurLine,3) = '***'
               * create procedure name and jump to code section
               cOutLine = '{\uldb '
               cOutLine = cOutLine + substr(cCurLine,4)
               cOutLine = cOutLine + '}{\v IDH_'
               cOutline = cOutLine + alltrim(str(aFoxProc[nMInx,2]))
               cOutLine = cOutLine + '} - '
               fputs(hOutFile,cOutLine)
            else
               fputs(hOutFile,substr(cCurLine,3))
            endif
            nExtInx = nExtInx + 1
            cCurLine = mline(methods,nStartLine + nExtInx)
         enddo
         fputs(hOutFile,'\par')
      endif
   endfor
endif

* do public methods section next
if nMthdPub > 1
   * order function names
   asort(aMthdPub)
   * create section header
   fputs(hOutFile,'\par New User Defined Public Methods: \par')
   * step through each function and write description to main topic
   for nMInx = 1 to alen(aMthdPub,1)
      nExtInx = 1
      nStartLine = atcline(aMthdPub[nMInx,3],methods)
      if nStartLine > 0
         cCurLine = mline(methods,nStartLine + nExtInx)
         do while left(cCurLine,2) = '**'
            if left(cCurLine,3) = '***'
               * create procedure name and jump to code section
               cOutLine = '{\uldb '
               cOutLine = cOutLine + substr(cCurLine,4)
               cOutLine = cOutLine + '}{\v IDH_'
               cOutline = cOutLine + alltrim(str(aMthdPub[nMInx,2]))
               cOutLine = cOutLine + '} - '
               fputs(hOutFile,cOutLine)
            else
               fputs(hOutFile,substr(cCurLine,3))
            endif
            nExtInx = nExtInx + 1
            cCurLine = mline(methods,nStartLine + nExtInx)
         enddo
         fputs(hOutFile,'\par')
      endif
   endfor
endif

* do protected methods section next
if nMthdProt > 1
   * order function names
   asort(aMthdProt)
   * create section header
   fputs(hOutFile,'\par New User Defined Protected Methods: \par')
   * step through each function and write description to main topic
   for nMInx = 1 to alen(aMthdProt,1)
      nExtInx = 1
      nStartLine = atcline(aMthdProt[nMInx,3],methods)
      if nStartLine > 0
         cCurLine = mline(methods,nStartLine + nExtInx)
         do while left(cCurLine,2) = '**'
            if left(cCurLine,3) = '***'
               * create procedure name and jump to code section
               cOutLine = '{\uldb '
               cOutLine = cOutLine + substr(cCurLine,4)
               cOutLine = cOutLine + '}{\v IDH_'
               cOutline = cOutLine + alltrim(str(aMthdProt[nMInx,2]))
               cOutLine = cOutLine + '} - '
               fputs(hOutFile,cOutLine)
            else
               fputs(hOutFile,substr(cCurLine,3))
            endif
            nExtInx = nExtInx + 1
            cCurLine = mline(methods,nStartLine + nExtInx)
         enddo
         fputs(hOutFile,'\par')
      endif
   endfor
endif

* do hidden methods section last
if nMthdHidn > 1
   * order function names
   asort(aMthdHidn)
   * create section header
   fputs(hOutFile,'\par New User Defined Hidden Methods: \par')
   * step through each function and write description to main topic
   for nMInx = 1 to alen(aMthdHidn,1)
      nExtInx = 1
      nStartLine = atcline(aMthdHidn[nMInx,3],methods)
      if nStartLine > 0
         cCurLine = mline(methods,nStartLine + nExtInx)
         do while left(cCurLine,2) = '**'
            if left(cCurLine,3) = '***'
               * create procedure name and jump to code section
               cOutLine = '{\uldb '
               cOutLine = cOutLine + substr(cCurLine,4)
               cOutLine = cOutLine + '}{\v IDH_'
               cOutline = cOutLine + alltrim(str(aMthdHidn[nMInx,2]))
               cOutLine = cOutLine + '} - '
               fputs(hOutFile,cOutLine)
            else
               fputs(hOutFile,substr(cCurLine,3))
            endif
            nExtInx = nExtInx + 1
            cCurLine = mline(methods,nStartLine + nExtInx)
         enddo
         fputs(hOutFile,'\par')
      endif
   endfor
endif

* create procedure text sections using arrays to select sections
* start with FoxProc array
if nFoxProc > 1
   CreateProcListing(aFoxProc)
endif

* do MthdPub array next
if nMthdPub > 1
   CreateProcListing(aMthdPub)
endif

* then do MthdProt array
if nMthdProt > 1
   CreateProcListing(aMthdProt)
endif

* do MthdHidn array last
if nMthdHidn > 1
   CreateProcListing(aMthdHidn)
endif

* set memowidth to starting value
set memowidth to nOrgMemoWidth

return nCurID
