*/ Traverse.prg
*/ The traverseoutlook class drills through all folders 
*/ in outlook in order to access items contained in 
*/ each folder.

oTraverse = CreateObject("traverseoutlook")
oTraverse.BeginTraverse

Define Class TraverseOutlook As Custom
   nNestingLevel = 0
   oOutLookObject = Null
   olNameSpace = Null
   
   Procedure Init
      With This
         .oOutLookObject = CREATEOBJECT("Outlook.Application")
         .olNameSpace = .oOutlookObject.GetNameSpace("MAPI")
      EndWith   
   EndProc
   
   Procedure BeginTraverse
      Local folder
      For Each folder ;
       In This.olNameSpace.Folders
         This.ProcessFolder(folder)
      Next Folder
   EndProc

   Procedure ProcessFolder(subfolder)
      This.nNestingLevel = This.nNestingLevel + 1
      ?Replicate(Chr(9),This.nNestingLevel-1),subfolder.name
      */ By using recursion, up to 128 levels 
      */ of nested folders can be accessed.
      For Each folder in subfolder.Folders
         This.ProcessFolder(folder)      
      Next folder
      For Each item in subfolder.Items
         ?Replicate(Chr(9),This.nNestingLevel),item.subject
      Next item
      This.nNestingLevel = This.nNestingLevel - 1
   EndProc
EndDefine